#!/bin/ksh
#
#  creation de nouveaux stgpool normes agora
#

typeset -u Node StgPool

if test $# -eq 0 
then
cat << @EOFF

$0 Node=' ' LibNode=' ' StgPool=' ' RetStgPool=' ' LibStgPool=' '

@EOFF
exit 
fi

while [ $# -gt 0 ]
do
 eval $( echo $1 | sed "s/=/=\'/;s/$/\'/")
shift
done


## echo " Saisir Node            : \c"
## read Node
## echo " Saisir Libelle Node    : \c"
## read LibNode
## 
## echo " Saisir StgPool         : \c"
## read StgPool
## echo " Retention StgPool      : \c"
## read RetStgPool
## echo " Saisir Libelle StgPool : \c"
## read LibStgPool

ExisteNode=$( ./Select_Table_TSM.ksh COLAFFICHE='NODE_NAME' TABLE='NODES' COLCIBLE='NODE_NAME VARCHAR' CRITCIBLE='=' VALCIBLE=$Node SQLDISPLAYMODE='Narrow' | tail +6 | grep -v ANS | sed '/^$/d' )

##--------------------------------------------
##----- Creation des DOMAIN et POLICY
##--------------------------------------------

if test ! -z "${Node}"
then
if test -z "${ExisteNode}"
then
cat << @EOFF

define domain DM_${Node} DESC="${LibNode}"
define POLICYSET DM_${Node} PS_${Node}
@EOFF
fi
fi

case $( echo ${StgPool} | cut -d"_" -f2 ) in 
BDD)
cat << @EOFF

DEFINE MGMTCLASS DM_${Node} PS_${Node} MC_BDD_${Node} desc="Mgmt classe BDD "
def stg ${StgPool} DEVTL2 Po=PR  acc=readwrite maxsi=NOL CRCDATA=YES HIG=90 LOW=70 MIGPR=1 MAXSCR=50 MIGD=0 MIGC=yes dataf=NATIVE col=no DESCription="${LibStgPool}"
define COpygroup DM_${Node} PS_${Node} MC_BDD_${Node} type=backup dest=${StgPool} VERE=NOL VERD=NOL RETE=${RetStgPool} RETO=${RetStgPool}
assign defmgmtclass DM_${Node} PS_${Node} MC_BDD_${Node}
validate policyset DM_${Node} PS_${Node}   
activate policyset DM_${Node} PS_${Node}
Y

@EOFF
;;

BKUP)
cat << @EOFF

DEFINE MGMTCLASS DM_${Node} PS_${Node} MC_FILE_${Node} desc="Mgmt classe FILE "
def stg ${StgPool} DEVTL2 Po=PR  acc=readwrite maxsi=NOL CRCDATA=YES HIG=90 LOW=70 MIGPR=1 MAXSCR=50 MIGD=0 MIGC=yes dataf=NATIVE col=no DESCription="${LibStgPool}"
define COpygroup DM_${Node} PS_${Node} MC_FILE_${Node} type=backup dest=${StgPool} VERE=NOL VERD=NOL RETE=${RetStgPool} RETO=${RetStgPool}
assign defmgmtclass DM_${Node} PS_${Node} MC_FILE_${Node}
validate policyset DM_${Node} PS_${Node}   
activate policyset DM_${Node} PS_${Node}
Y

@EOFF
;;

DSK)

TypePool=$(  echo ${StgPool} | cut -d"_" -f3 )

##--------------------------------------------
##----- Creation des POOL DISQUES
##--------------------------------------------

case $(  echo ${StgPool} | cut -d"_" -f3 ) in
BDD)
   PoolVide="/POOLBDD?/VOL??"
   PoolTaille=4096
          ;;
BKUP)
   PoolVide="/POOLFIC?/VOL??"
   PoolTaille=512
          ;;

esac

cat << @EOFF

def stg ${StgPool} disk Po=PR acc=readwrite maxsi=NOL HIG=85 LOW=40 MIGPR=1 MIGD=0 NEXTstgpool=$( echo ${StgPool} | sed 's/_DSK//' ) MIGC=yes DESCription="${LibStgPool}"
define vol ${StgPool} ${PoolVide} formatsize=${PoolTaille}

@EOFF
;;

esac


##--------------------------------------------
##----- Creation des NODES
##--------------------------------------------

cat << @EOFF

REGISTER NODE ND_${Node} ${Node} CONTACT="${LibNode}"  DOMAIN=DM_${Node} COMPRESSION=CLIENT AUTOFSRENAME=NO FORCEPWRESET=NO TYPE=CLIENT KEEPMP=YES MAXNUMMP=2 URL=http://${Node}.cncimafap.msanet:1471 VALIDATEPROTOCOL=NO 

@EOFF

