#/bin/ksh
#
# Pour fonction GENERER_RESTO_PRA sur menu clients
#

set -a
##set -xva

#-------- recuperer les parametres passes
test $# -eq 0 && exit 9

while [ $# -gt 0 ]
do
eval $( echo $1 | sed "s/=/=\'/;s/$/\'/")
shift
done

#--------------- Charger variable propre au script
client=${CLIENT}
clientO=${client}
node=${NODE}

pitdate=
test ! -z "${PITDATE}" && pitdate="-pitdate=${PITDATE}"
pittime=
test ! -z "${PITTIME}" && pittime="-pittime=${PITTIME}"

prompt=
test ! -z "${FILTRE}" && prompt="-${FILTRE}"

##--- parametre specifique si snapshot

connecttsm="-se=${node}"
excluVG=
 test -z "${GENERER}" && echo " ================================================================"

case ${node} in
      GA_CB) client=helios
             connecttsm="-virtualnodename=GA_CB -password=GA_tech0"
              test -z "${GENERER}" && echo "\n Node ${node} pour snapshot du client ${client} sur ${clientO}\n"
              ;;
      GA_C1) client=lassie
             connecttsm="-virtualnodename=GA_C1 -password=GA_c1001"
              test -z "${GENERER}" && echo "\n Node ${node} pour snapshot du client ${client} sur ${clientO}\n"
              ;;
esac

#--------- Scripts a generer aller copier sur le node donne et l executer

ficGENERER_RESTO_PRA=/tmp/GENERER_RESTO_PRA_${node}_$$.ksh

cat << @@EOFF > ${ficGENERER_RESTO_PRA}
#====================================================================
#
# Script genere par le menu tsmmenu sur Hermes fonction ${FONCTION}
#
#====================================================================
#
#!/bin/ksh

##set -e

#--------
#-------- Verifier que l on est sur le bon serveur
#--------
if test \"${client}\" != \"\$( uname -n )\"
then
  echo "Ce script est a lancer sur le serveur ${client} et non pas sur \$( uname -n )\"
  exit 9
fi

#--------
#-------- Les VG a traiter = VG du serveur - les exclus du fichier exclude.lst
#--------
LesVG="\$( lsvg | egrep -v -f /etc/getima/backup/exclude.lst )"
DebCdeAfaire="dsmc restore image ${connecttsm} ${prompt} \\\${pitdate} \\\${pittime} "
FinCdeAfaire=" -noprompt \\\${pitdate} \\\${pittime}"
CdeGeneres=/tmp/RESTO_PRA_${node}_\$( date +%Y%m%d )
FsckGeneres=/tmp/FSCK_PRA_${node}_\$( date +%Y%m%d )
MountGeneres=/tmp/FSCK_PRA_${node}_\$( date +%Y%m%d )
ListeFS=/tmp/FS_PRA_${node}_\$( date +%Y%m%d )
pitdate="${pitdate}"
pittime="${pittime}"

#-------- Cas particuliers ------------------------------------
case ${node} in
#-------------- Cas client snapshote recuperer vg snapshote
      GA_CB|GA_C1)
             LesVG=\"\$( awk '{ split(\$8,t,\"_\");if ( t[4] != NULL && \$1 !~ /#/ ) { printf(\"%s \", t[4]) | \"tr 'A-Z' 'a-z'\" } }' ${PATH_TSM}/SNAPSHOT/CREATE_SESSION_$( echo ${client} | tr '[a-z]' '[A-Z]') )\"
              ;;

#-------------- Cas client avec snapshots exclure les FS snapshotes
      CB_TECH|C1_TECH)
             cat /etc/getima/backup/exclude.lst > /tmp/ExcluVG_\$\$
             awk '{ split(\$8,t,\"_\");if ( t[4] != NULL && \$1 !~ /#/ ) { printf(\"%s\\n\", t[4]) | \"tr 'A-Z' 'a-z'\" } }' ${PATH_TSM}/SNAPSHOT/CREATE_SESSION_$( echo ${client} | tr '[a-z]' '[A-Z]') >> /tmp/ExcluVG_\$\$
             LesVG=\"\$( lsvg | egrep -v -f /tmp/ExcluVG_\$\$ )\"
             test -f /tmp/ExcluVG_\$\$ && rm /tmp/ExcluVG_\$\$
             DebCdeAfaire="dsmc restore image ${connecttsm} "
              ;;
esac

#--------
#-------- Script a envoyer et a derouler sur le serveur concerne
#--------
cat << @EOFF

#=====================================================#
#=    Bilan serveur \$( uname -n | tr 'a-z' 'A-Z')
#=    pour TSM :
#=       Client = ${client}
#=       Node   = ${node}
#= Commandes sur serveur \$( uname -n | tr 'a-z' 'A-Z') sous \${CdeGeneres}
#=====================================================#

@EOFF

#----------- Generer commandes de restauration
if test ! -z \"\${LesVG}\"
then
cat << @EOFF  > \${CdeGeneres}
#============
#= Pour renseigner ( voir sur serveur format date )
#=
#=  pitdate="-pitdate=JJ-MM-SSAA"
#=  pittime="-pittime=HH:MM:SS"
#=
#============

pitdate="${pitdate}"
pittime="${pittime}"

#--- Pour ne pas executer les commandes resto par erreur
#---  A retirer pour executer
exit

@EOFF

echo "exit " > \${FsckGeneres}
echo "exit " > \${MountGeneres}

##echo \"\${LesVG}\" | tr \" \" \"\\n\" | lsvg -il | awk '{ if ( \$2 ~ /jfs/ && \$7 != \"N/A\" && \$7 != \"None\") { print \$7 }}' | sed \"s/^/\${DebCdeAfaire}/;s/$/ \${FinCdeAfaire}/\" | tee -a \${CdeGeneres}
##echo \"\${LesVG}\" | grep -wv \"None\" | xargs lsvg -l | awk '{ if ( \$2 ~ /jfs/ && \$7 != \"N/A\" && \$7 != \"None\") { print \$7 }}' | sed \"s/^/\${DebCdeAfaire}/\" | tee -a \${CdeGeneres}

##echo \"\${LesVG}\" | grep -wv \"None\" | xargs lsvg -l | awk '{ if ( \$2 ~ /jfs/ && \$7 != \"N/A\" && \$7 != \"None\") { print \$7 }}' > \${ListeFS}
echo \"\${LesVG}\" | grep -wv \"None\" | xargs lsvg -l | awk '
        \$7 == \"N/A\"    { next } ;
        \$7 == \"None\"    { next } ;
        \$2 ~ /jfs/ { print \$7 } ; '  > \${ListeFS}


sed \"s/^/\${DebCdeAfaire}/\" \${ListeFS} | sort -r | tee -a  \${CdeGeneres}
sed \"s/^/fsck -y /\" \${ListeFS} | tee -a \${FsckGeneres}
sed \"s/^/mount /\" \${ListeFS} | sort | tee -a \${MountGeneres}

else
echo "Rien a restaurer pour le node  ${node}"
fi

test -f ${ficGENERER_RESTO_PRA} && rm ${ficGENERER_RESTO_PRA}

@@EOFF

#----------- 
#----------- ON veut juste le script a derouler sur le serveur donne
#----------- 
 test ! -z "${GENERER}" && cat ${ficGENERER_RESTO_PRA} && exit 0

#----------- 
#----------- Sinon on demande l execution online
#----------- 
echo " script : ${ficGENERER_RESTO_PRA} \n"
echo " Client : ${client}"
echo " Node   : ${node}"
##cat ${ficGENERER_RESTO_PRA}
echo " "
echo " ================================================================"
echo " Voulez vous executer ce script sur le seveur ${client} (O/N) :\c"
read reponse

case $reponse in
      O)
         case ${client} in 
          $( uname -n ))
               echo "\n"
               ksh ${ficGENERER_RESTO_PRA} | sed "s/\${pitdate}/${pitdate}/;s/\${pittime}/${pittime}/"
               rc=$?
                                  ;;
             *) 
               echo "\nCopie de ${ficGENERER_RESTO_PRA} dans ${client}:/tmp"
               scp ${ficGENERER_RESTO_PRA} root@${client}:/tmp
               echo "\nexecution de ${client}: ${ficGENERER_RESTO_PRA}"
               ssh root@${client} "ksh ${ficGENERER_RESTO_PRA}" | sed "s/\${pitdate}/${pitdate}/;s/\${pittime}/${pittime}/"
               rc=$?
               test -f ${ficGENERER_RESTO_PRA} && rm ${ficGENERER_RESTO_PRA}
                                  ;;
         esac
          ;;
esac

exit $rc
