#/bin/ksh
#
# Pour fonction LISTEFS_SAUVES_NOSAUVES_PRA sur menu clients
#

set -a
##set -xva

#-------- recuperer les parametres passes
test $# -eq 0 && exit 9

while [ $# -gt 0 ]
do
eval $( echo $1 | sed "s/=/=\'/;s/$/\'/")
shift
done

#--------------- Charger variable propre au script
client=${CLIENT}
clientO=${client}
node=${NODE}

##--- parametre specifique si snapshot

connecttsm="-se=${node}"
excluVG=
 test -z "${GENERER}" && echo " ================================================================"

case ${node} in
      GA_CB) client=helios
             connecttsm="-virtualnodename=GA_CB -password=GA_tech0"
              test -z "${GENERER}" && echo "\n Node ${node} pour snapshot du client ${client} sur ${clientO}\n"
              ;;
      GA_C1) client=lassie
             connecttsm="-virtualnodename=GA_C1 -password=GA_c1001"
              test -z "${GENERER}" && echo "\n Node ${node} pour snapshot du client ${client} sur ${clientO}\n"
              ;;
esac

#--------- Scripts a generer aller copier sur le node donne et l executer

ficLISTEFS_SAUVES_NOSAUVES_PRA=/tmp/LISTEFS_SAUVES_NOSAUVES_PRA_${node}_$$.ksh

cat << @@EOFF > ${ficLISTEFS_SAUVES_NOSAUVES_PRA}
#====================================================================
#
# Script genere par le menu tsmmenu sur Hermes fonction ${FONCTION}
#
#====================================================================
#
#!/bin/ksh

##set -e
set -a

#--------
#-------- Verifier que l on est sur le bon serveur
#--------
if test \"${client}\" != \"\$( uname -n )\"
then
  echo "Ce script est a lancer sur le serveur ${client} et non pas sur \$( uname -n )\"
  exit 9
fi

#--------
#-------- Les VG a traiter = VG du serveur - les exclus du fichier exclude.lst
#--------
LesVG="\$( lsvg | egrep -v -f /etc/getima/backup/exclude.lst )"
FSsaved=/tmp/FS_SAVED_PRA_${node}_\$( date +%Y%m%d )
FSNotsaved=/tmp/FS_NOT_SAVED_PRA_${node}_\$( date +%Y%m%d )

#-------- Cas particuliers ------------------------------------
case ${node} in
#-------------- Cas client snapshote recuperer vg snapshote
      GA_CB|GA_C1)
             LesVG=\"\$( awk '{ split(\$8,t,\"_\");if ( t[4] != NULL && \$1 !~ /#/ ) { printf(\"%s \", t[4]) | \"tr 'A-Z' 'a-z'\" } }' ${PATH_TSM}/SNAPSHOT/CREATE_SESSION_$( echo ${client} | tr 'a-z' 'A-Z') )\"
              ;;

#-------------- Cas client avec snapshots exclure les FS snapshotes
      CB_TECH|C1_TECH)
             awk '{ split(\$8,t,\"_\");if ( t[4] != NULL && \$1 !~ /#/ ) { printf(\"%s\\n\", t[4]) | \"tr 'A-Z' 'a-z'\" } }' ${PATH_TSM}/SNAPSHOT/CREATE_SESSION_$( echo ${client} | tr 'a-z' 'A-Z') > /tmp/ExcluVG_\$\$
             LesVG=\"\$( lsvg | egrep -v -f /tmp/ExcluVG_\$\$ )\"
             test -f /tmp/ExcluVG_\$\$ && rm /tmp/ExcluVG_\$\$
             DebCdeAfaire="dsmc restore image ${connecttsm} "
              ;;
esac

#--------
#-------- Script a envoyer et a derouler sur le serveur concerne
#--------
cat << @EOFF

#=====================================================#
#=    Bilan serveur \$( uname -n | tr 'a-z' 'A-Z')
#=    pour TSM :
#=       Client = ${client}
#=       Node   = ${node}
#=====================================================#

@EOFF

#----------- Generer commandes de restauration
if test ! -z \"\${LesVG}\"
then
#---------- Les FS sauvegardes
echo \"\${LesVG}\" | grep -wv \"None\" | xargs lsvg -l | awk '{ if ( \$2 ~ /jfs/ && \$7 != \"N/A\" && \$7 != \"None\") { print \$7 }}' > \${FSsaved}
#---------- Les FS Non sauvegardes
LesVG=\"\$( echo  \${LesVG} | sed 's/ /|/g' )\"
lsvg | egrep -wv \"None|\${LesVG}\" | xargs lsvg -l | awk '{ if ( \$2 ~ /jfs/ && \$7 != \"N/A\" && \$7 != \"None\") { print \$7 }}' > \${FSNotsaved}

nbrFSsaved=\$( awk 'END{ print NR }' \${FSsaved} )
nbrFSNotsaved=\$( awk 'END{ print NR }' \${FSNotsaved} )

awk 'BEGIN {
   f1=0;f2=0;

   ficFSsaved=ENVIRON["FSsaved"]
   ficFSNotsaved=ENVIRON["FSNotsaved"]
   nbficFSsaved=ENVIRON["nbrFSsaved"]
   nbficFSNotsaved=ENVIRON["nbrFSNotsaved"]

   souli="=================================================="
   printf("# %-50s # %-50s #\n", souli, souli)
   printf("# %-50s # %-50s #\n", "    "nbficFSsaved" FS sauvegardes ",  "     "nbficFSNotsaved" FS non sauvegardes ")
   printf("# %-50s # %-50s #\n", souli, souli)
#   printf("# %-50s # %-50s #\n", " ", " ")

    while ( f1==0 || f2==0 )
    {
      if ( f1 == 0 ) { if ( getline FSsaved < ficFSsaved == 0 ) f1++ } ;
      if ( f2 == 0 ) { if ( getline FSNotsaved < ficFSNotsaved == 0 ) f2++ } ;
      if ( f1==0 || f2==0 )
         { printf("# %-50s # %-50s #\n", FSsaved, FSNotsaved) ; }
         else
         { printf("# %-50s # %-50s #\n", souli, souli) ; }
      FSsaved="" ; FSNotsaved=""
    }
}'
else
echo "Pas de sauvegardes pour le node ${node} sur ${client} "
fi

test -f ${ficLISTEFS_SAUVES_NOSAUVES_PRA} && rm ${ficLISTEFS_SAUVES_NOSAUVES_PRA}
test -f \${FSsaved} && rm \${FSsaved}
test -f \${FSNotsaved} && rm \${FSNotsaved}

@@EOFF

#----------- 
#----------- ON veut juste le script a derouler sur le serveur donne
#----------- 
 test ! -z "${GENERER}" && cat ${ficLISTEFS_SAUVES_NOSAUVES_PRA} && exit 0

#----------- 
#----------- Sinon on demande l execution online
#----------- 
echo " script : ${ficLISTEFS_SAUVES_NOSAUVES_PRA} \n"
echo " Client : ${client}"
echo " Node   : ${node}"
echo " "
echo " ================================================================"
echo " Voulez vous executer ce script sur le seveur ${client} (O/N) :\c"
read reponse

case $reponse in
      O)
         case ${client} in 
          $( uname -n ))
               echo "\n"
               ksh ${ficLISTEFS_SAUVES_NOSAUVES_PRA}
               rc=$?
                                  ;;
             *) 
               echo "\nCopie de ${ficLISTEFS_SAUVES_NOSAUVES_PRA} dans ${client}:/tmp"
               scp ${ficLISTEFS_SAUVES_NOSAUVES_PRA} root@${client}:/tmp
               echo "\nexecution de ${client}: ${ficLISTEFS_SAUVES_NOSAUVES_PRA}"
               ssh root@${client} "ksh ${ficLISTEFS_SAUVES_NOSAUVES_PRA}"
               rc=$?
               test -f ${ficLISTEFS_SAUVES_NOSAUVES_PRA} && rm ${ficLISTEFS_SAUVES_NOSAUVES_PRA}
                                  ;;
         esac
          ;;
esac

exit $rc
