#/bin/ksh
#
# Pour fonction QUERY_DIFF_PRA sur menu clients
#

##set -xva
set -a

#--------- 
#--------- Prise en compte des parametres donnes
#--------- 
test $# -ne 2 && exit 9

client=$1
clientO=$1
node=$2

#--------- Cas particuliers si snapshot
#--------- 

connecttsm="-se=${node}"
excluVG=
echo " ================================================================"

case ${node} in
      GA_CB) client=helios
             connecttsm="-virtualnodename=GA_CB -password=GA_tech0"
             echo "\n Node ${node} pour snapshot du client ${client} sur ${clientO}\n"
              ;;
      GA_C1) client=lassie
             connecttsm="-virtualnodename=GA_C1 -password=GA_c1001"
             echo "\n Node ${node} pour snapshot du client ${client} sur ${clientO}\n"
              ;;
      CB_TECH|C1_TECH)
             echo "\nBesoin pour le node ${node} de recuperer les VG snapshotes sur ${client}\n"
             excluVG=$( ssh root@${client} " awk '{ split(\$8,t,\"_\");if ( t[2] != NULL && \$1 !~ /#/ ) { printf(\"|%s\", t[2]) | \"tr 'A-Z' 'a-z'\" } }' ${PATH_TSM}/SNAPSHOT/CREATE_SESSION_$( echo ${client} | tr '[a-z]' '[A-Z]') " )
              ;;
esac

#--------- 
#--------- Scripts a generer aller copier sur le node donne et l executer
#--------- 

ficQUERY_DIFF_PRA=/tmp/QUERY_DIFF_PRA_${node}_$$.ksh

cat << @@EOFF > ${ficQUERY_DIFF_PRA}

##set -ve

filesloc=/tmp/files_\$\$_local
filestsm=/tmp/files_\$\$_tsm
filesDEL=/tmp/DeleteFiles_\$\$_tsm_${client}

lsvg | egrep -v \"rootvg|^vsys|None${excluVG}\" | xargs lsvg -l | awk '{ if ( \$2 ~ /jfs/ && \$7 != \"N/A\" && \$7 != \"None\" ) { print \$7 }}' | sort -bifu > \${filesloc}

##dsmc q file ${connecttsm} | awk '{ if ( \$4 ~ /JFS/ ) { print \$5 } }' | sort -bifu > \${filestsm}
##dsmc q im ${connecttsm} | awk '{ if ( \$6 ~ /JFS/ ) { print \$11 } }' | sort -bifu >> \${filestsm}
##sort -bifu \${filestsm} >> \${filestsm}_temp
##mv \${filestsm}_temp \${filestsm}
dsmc q im ${connecttsm} | awk '{ if ( \$6 ~ /JFS/ ) { print \$11 } }' | sort -bifu > \${filestsm}

#=========== cas de compare
#-1 Suppresses the display of the first column (lines in File1).                  
#-2 Suppresses the display of the second column (lines in File2).                 
#-3 Suppresses the display of the third column (lines common to File1 and File2). 

##\$( comm -13 \${filesloc} \${filestsm} )
# ou #\$( diff \${filesloc} \${filestsm} | grep ">" )

##\$( comm -23 \${filesloc} \${filestsm} )
# ou #\$( diff \${filesloc} \${filestsm} | grep "<" )
#======================================
##\$( comm -13 \${filesloc} \${filestsm} | sed 's/^/q im /' )
##\$( test -f \${filesDEL} && echo "\nListe dans \${filesDEL} sur ${client}" )
##\$( comm -13 \${filesloc} \${filestsm} | sed 's/^/delete filespace ${node} /' | tee \${filesDEL} )

cat << @EOFF

#=====================================================#
#=    Bilan serveur \$( uname -n | tr 'a-z' 'A-Z')
#=    pour TSM :
#=       Client = ${client}
#=       Node   = ${node}
#=====================================================#

#-----------------------------------------------------#
#=== FS Inconnus sur \$( uname -n | tr 'a-z' 'A-Z')
#=== et Existes dans TSM  avec node ${node}
#------ Si on veut supprimer ces filespaces
#------  Aller sur ${client} en root et faire 
#---- dsmadmc -id=batch -pa=batch -noconfirm < \${filesDEL}
#-----------------------------------------------------#
\$( diff \${filesloc} \${filestsm} | grep ">" | sed 's#>#delete filespace ${node} #' | tee \${filesDEL} )

#-----------------------------------------------------#
#=== FS Connus sur \$( uname -n | tr 'a-z' 'A-Z')
#=== et Non Sauvegardes dans TSM  avec node ${node}
#-----------------------------------------------------#
\$( diff \${filesloc} \${filestsm} | grep "<" | sed 's#<##' )
@EOFF

rm \${filesloc} \${filestsm} ${ficQUERY_DIFF_PRA}

@@EOFF

echo " script : ${ficQUERY_DIFF_PRA} \n"
echo " Client : ${client}"
echo " Node   : ${node}"
##cat ${ficQUERY_DIFF_PRA}
echo " "
echo " ================================================================"
echo " Voulez vous executer ce script sur le seveur ${client} (O/N) :\c"

read reponse

case $reponse in
      O)
         case ${client} in 
          $( uname -n ))
               echo "\n"
               ksh ${ficQUERY_DIFF_PRA}
                                  ;;
             *) 
               echo "\nCopie de ${ficQUERY_DIFF_PRA} dans ${client}:/tmp"
               scp ${ficQUERY_DIFF_PRA} root@${client}:/tmp
               echo "\nexecution de ${client}: ${ficQUERY_DIFF_PRA}"
               ssh root@${client} "ksh ${ficQUERY_DIFF_PRA}"

               test -f ${ficQUERY_DIFF_PRA} && rm ${ficQUERY_DIFF_PRA}
                                  ;;
         esac
          ;;
esac

