#!/bin/ksh
#
#  Suivi nombre de sessions par STATE et process
#

#---------- Main
##set +x
set -a

#-- Chargement des variables necessaires au scripts ----------------#
. ${PATH_TSM}/data/requete_control_TSM_$(uname -n).parm


#----------- Nettoyer /tmp
find /tmp -name "Nbre_Sessions_TSM_????????.txt" -mtime +60 -exec rm {} \;

totsess=0
AccesTsm="${AccesTsm} -dataonly=yes"

FicOut=/tmp/Nbre_Sessions_TSM_$( date +%d%m%Y ).txt

##echo "le "$( date +%d"/"%m"/"%Y" - "%H":"%M":"%S )

exec 1>> ${FicOut}

echo "---------------------------------------------- "
date
echo "---------------------------------------------- "
echo "      ------- sessions actives -----"

for fndterm in $( ${AccesTsm} "select STATE from SESSIONS Group by STATE" )
do
echo $fndterm" = \c"
fndterm="'${fndterm}'"

for session in $( ${AccesTsm} "select count(SESSION_ID) from SESSIONS where STATE = ${fndterm}" )
do
echo ${session}
(( totsess+=session ))
done

done

echo "Total = ${totsess}"

echo "      ------- process actifs -------"
test $( ${AccesTsm} "select count(process) from processes" ) -gt 0 && ${AccesTsm} -DISPLaymode=LISt "select process_num,process,status from processes"

echo "      ------- Consumption Log -------"
${AccesTsm} -DISPLaymode=LISt "q log f=d"

echo "      ------- Query DB -------"
${AccesTsm} -DISPLaymode=LISt "q db f=d"

echo "      ------- Query MO -------"
${AccesTsm} -DISPLaymode=LISt "q mo"

## test -f ${FicOut} && rm ${FicOut}
exit 0
