#!/bin/ksh
#=========================================================================
#
#  Redacteur   : JF.GONZALEZ GARCIA
#  Copyright   : CIMAFAP-NANTERRE
#  date        : 16 octobre 2009
#  Projet      : TSM
#  Version     : 1.0
#
#  Description : Tableau summary de save par noeud sur une journe
#
#-------------------------------------------------------------------------------------
#
#  Traitement  : 
#
#-------------------------------------------------------------------------------------
#

set -a

if test $# -lt 2 
then

cat << @EOFF

  Donner date de debut et date de fin 
  style

  Summary_SaveNode_perDay.ksh 2009-10-15 2009-10-16

@EOFF

exit 9
fi


#------------------------ parm attendus
DateD=$1
DateF=$2
TimeD="00:00:00 000000"
TimeF="$TimeD"

COMMUN=/environnements/GETIMA/commun

. ${PATH_TSM}/data/requete_control_TSM_hermes.parm

AccesTsm="${AccesTsm} -dataonly=yes"

#================== Table Colonnes pour l edition
Edit_Zones="\
 Node;____Node;20\
 ACTIVITY;Activity;10\
 NBytes;___en__Bytes;20\
 NKilo;_____en__Ko;20\
 NMega;_____en__Mo;20\
 NGiga;_____en__Go;20"


  CNBytes=0
  CNKilo=0
  CNMega=0
  CNGiga=0

 Souli=";=;$( $COMMUN/outils/Edit_Tableau.exe longl ${Edit_Zones} )"

#======== Fonction Edit
cat << @EOFF
     
$( $COMMUN/outils/Edit_Tableau.exe souli ${Souli} )

          Voici le tableau recapitulant le nombre de caracteres sauvegards par node TSM 

             du ${DateD}  $( echo ${TimeD} | cut -c1-8 ) au ${DateF}  $( echo ${TimeF} | cut -c1-8 )

@EOFF
     $COMMUN/outils/Edit_Tableau.exe souli ${Souli}
     $COMMUN/outils/Edit_Tableau.exe titre ${Edit_Zones}
     $COMMUN/outils/Edit_Tableau.exe souli ${Souli}

#----------- acces TSM et tableau
 ${AccesTsm} "select ENTITY,ACTIVITY,sum(BYTES) from summary where entity not like '%STG%' and ( start_time>='${DateD} ${TimeD}' and end_time<='${DateF} ${TimeF}')  group by entity,ACTIVITY" | while read Node ACTIVITY NBytes
do

# Node=$( echo $ligne | awk '{ print $1 }' )
# NBytes=$( echo $ligne | awk '{ print $2 }' | sed 's/ //g' )

  NKilo=$NBytes
  (( NKilo/=1024 ))
  NMega=$NKilo
  (( NMega/=1024 ))
  NGiga=$NMega
  (( NGiga/=1024 ))

  (( CNBytes+=NBytes ))
  (( CNKilo+=NKilo ))
  (( CNMega+=NMega ))
  (( CNGiga+=NGiga ))

  $COMMUN/outils/Edit_Tableau.exe ligne ${Edit_Zones}

  ACTIVITY=

done

 $COMMUN/outils/Edit_Tableau.exe souli ${Souli}

 Node=TOTAUX
 NBytes=$CNBytes
 NKilo=$CNKilo
 NMega=$CNMega
 NGiga=$CNGiga
 ACTIVITY=


  $COMMUN/outils/Edit_Tableau.exe ligne ${Edit_Zones}
#     $COMMUN/outils/Edit_Tableau.exe titre ${Edit_Zones}
 $COMMUN/outils/Edit_Tableau.exe souli ${Souli}
