#!/bin/ksh
#===============================================================================
#
# Declencher les Space Reclamation sur les STG de TAPE sur la semaine
#
# Traitement :
#
# Lundi    -> Mardi = Reclaim STG PRIMARY  85% avec devclass!=DISK
#
# Mercredi -> Jeudi = Reclaim STG COPY  85% avec COLLOCATE=NO and devclass!=DISK
#
# Vendredi          = Reclaim STG COPY  85% avec COLLOCATE!=NO and devclass!=DISK
#
#===============================================================================
ReqTsm()
{
set -vx
${AccesTsm} -dataonly=yes -tab -displ=list "SELECT 'update stg ' ||STGPOOL_NAME|| ' reclaim=${taux} reclaimpr=${process}' from volumes where PCT_RECLAIM !< ${taux} and stgpool_name in ( select STGPOOL_NAME from STGPOOLS where POOLTYPE = '${PoolType}' ${Collocate} and DEVCLASS != 'DISK' ) group by STGPOOL_NAME"
}
#==========================================================================
#====================== MAIN ==============================================
#==========================================================================
set +x
set -ae
set -vx

#-- Chargement des variables necessaires au scripts ----------------#
. ${PATH_TSM}/data/requete_control_TSM_$(uname -n).parm

#-------- recuperer parametres donnes
# Possible
#       jour= si Dimanche =0 lundi=1 ...
#       taux= taux reclaim demande
#       process= nombre de process simultane
#----------------------------------------------------
while [ $# -gt 0 ]
do
eval $( echo $1 | sed "s/=/=\'/;s/$/\'/")
shift
done

#----------------------------------------------------
# Controles valeurs donnees
#----------------------------------------------------
#
test -z "${jour}" && jour=$(date +%w)
test -z "${taux}" && taux=55
test -z "${process}" && process=1

#----------------------------------------------------------------------------------
# Traitement :
#----------------------------------------------------------------------------------
#
case ${jour} in
     1|2) PoolType=PRIMARY
          Collocate=""
            ;;

     3|4) PoolType=COPY
 Collocate="and COLLOCATE = 'NO'"
            ;;

       5) PoolType=COPY
          Collocate="and COLLOCATE = 'NO'"
#------- On force process
          process=2
            ;;

       *) exit
            ;;
esac

ReqTsm | ${AccesTsm}

exit $?
