#!/bin/ksh
#
#     [Dec 15 2009, 13:41:50]
#
#  Verification sur TSM
#
#---------------------------------------------
#  MAIN
#---------------------------------------------
#
set -a

test $# -eq 1 && mail= || mail=Oui

#-- Chargement des variables necessaires au scripts ----------------#
. ${PATH_TSM}/data/requete_control_TSM_$(uname -n).parm


#---------- Si pas TSM on sort

${AccesTsm} -dataonly=yes -Quiet q status || exit

#
#---------------------------------------------
# Execution des utilitaires souhaites
#---------------------------------------------
#
TabUtiLiTaire="\
 Count_Nbre_bandes_Volrange_scratchs.ksh#1600\
 Extract_ERREURS_log.ksh#\
 Extract_WARNINGS_log.ksh#\
 Liste_cartouches_ejectees.ksh#1200\
 Liste_cartouches_pour_memogarde.ksh#1000\
 Liste_cartouches_writeprotect.ksh#1000\
 Verification_NODES_Locked.ksh#1000\
 Verification_database.ksh#\
 Verification_demande_audit.ksh#\
 Verification_k7_read-only.ksh#\
 Verification_k7_unavailable.ksh#\
 Verification_paths.ksh#\
 Verification_stgpools_MAXscratch.ksh#"

for UtiLiTaire in ${TabUtiLiTaire}
do

MaxTime=$( echo ${UtiLiTaire} | cut -d"#" -f2 )
test -z "${MaxTime}" && MaxTime=9999
UtiLiTaire=$( echo ${UtiLiTaire} | cut -d"#" -f1 )

if test $(date +%H%M) -le ${MaxTime}
then 

Script=${PathOutils}/${UtiLiTaire}
LibMail="[TSM - $( uname -n ) ] $( head -n +5 ${Script}  |  sed "s/#//g;s/-//g;s/=//g;/^$/d;/^!/d" )"

echo "======================================================================================"
echo "${LibMail}"
echo "======================================================================================"

case $mail in 
        Oui)
totscrath=
if test "${UtiLiTaire}" = "Count_Nbre_bandes_Volrange_scratchs.ksh" 
then
     ${Script} > ${FicOut}
     totscrath="$? %"
      mail -s"${LibMail} ${totscrath}" ${DestMail} < ${FicOut}
else
eval ${Script} | tee ${FicOut} | test $( grep -c "ANS8001I Return code 11" ) -eq 0 && mail -s"${LibMail} ${totscrath}" ${DestMail} < ${FicOut} || rm ${FicOut}
fi
;;
          *)
. ${Script}
;;
esac

fi
done
test -f ${FicOut} && rm ${FicOut}

exit

############################################################################################################
#
# ============== ANCIEN TRAITEMENT
# ============== ANCIEN TRAITEMENT
# ============== ANCIEN TRAITEMENT
#
############################################################################################################

#!/bin/ksh
#
#     [Dec 15 2009, 13:41:50]
#
#  Verification sur TSM
#
RequeteDDe()
{
case $mail in 
        Oui)
eval ${Cde} | tee ${FicOut} | test $( grep -c "ANS8001I Return code 11" ) -eq 0 && mail -s"${LibMail}" ${DestMail} < ${FicOut} || rm ${FicOut}
;;
          *)
echo "======================================================================================"
echo "${LibMail}"
echo "======================================================================================"
eval ${Cde} | tee ${FicOut} | test $( grep -c "ANS8001I Return code 11" ) -eq 0 && cat ${FicOut} || rm ${FicOut}
;;
esac

test -f ${FicOut} && rm ${FicOut}
}

#
#---------------------------------------------
#  MAIN
#---------------------------------------------
#
set -a

test $# -eq 1 && mail= || mail=Oui

. $( dirname $0 )/requete_control_TSM_$(uname -n).parm

#---------- Si pas TSM on sort

dsmadmc -id=${UserTSm} -pa=${PassTsm} -dataonly=yes -Quiet q status || exit

#
#---------------------------------------------
# Verification des paths
#---------------------------------------------
#
LibMail="${TitreMail} Verification des paths "
Cde="${PathScripts}/SMIT_TSM/Select_Table_TSM.ksh COLAFFICHE='SOURCE_NAME,SOURCE_TYPE,DESTINATION_NAME,DESTINATION_TYPE,LIBRARY_NAME,NODE_NAME,ONLINE' TABLE='PATHS' COLCIBLE='ONLINE                 VARCHAR' CRITCIBLE='!=' VALCIBLE='YES' SQLDISPLAYMODE='Narrow'"
RequeteDDe

#
#---------------------------------------------
# Verification des stgpools MAXscratch atteint
#---------------------------------------------
#
LibMail="${TitreMail} Verification des stgpools MAXscratch atteint"
Cde="${PathScripts}/SMIT_TSM/Select_Table_TSM.ksh COLAFFICHE='STGPOOL_NAME,MAXSCRATCH,NUMSCRATCHUSED' TABLE='STGPOOLS' COLCIBLE='NUMSCRATCHUSED         INTEGER' CRITCIBLE='=' VALCIBLE='MAXSCRATCH' SQLDISPLAYMODE='Wide'"
RequeteDDe

#
#---------------------------------------------
# Verification de la database > 90%
#---------------------------------------------
#
LibMail="${TitreMail} Verification de la database > 90% "
Cde="${PathScripts}/SMIT_TSM/Select_Table_TSM.ksh COLAFFICHE='PCT_UTILIZED' TABLE='DB' COLCIBLE='PCT_UTILIZED           DECIMAL' CRITCIBLE='>' VALCIBLE='90' SQLDISPLAYMODE='Narrow'"
RequeteDDe

#
#---------------------------------------------
# Verification si demande audit
#---------------------------------------------
#
LibMail="${TitreMail} Verification si demande audit"
if test $( date +%H%M ) -gt 0800
 then
Cde="dsmadmc -id=${UserTSm} -pa=${PassTsm}  QUERY 'ACTLOG' BEGINTIME='-1' MSGNO='8358' ORIGINATOR='ALL'"
 else
Cde="dsmadmc -id=${UserTSm} -pa=${PassTsm}  QUERY 'ACTLOG' BEGINDATE='-1' MSGNO='8358' ORIGINATOR='ALL'"
fi
RequeteDDe

#
#---------------------------------------------
# Verification cartouches unavailable
#---------------------------------------------
#
LibMail="${TitreMail} Verification cartouches unavailable"
Cde="dsmadmc -id=${UserTSm} -pa=${PassTsm} QUERY 'VOLUME' ACC='UNAV'"
RequeteDDe

#
#---------------------------------------------
# Verification cartouches read-only
#---------------------------------------------
#
LibMail="${TitreMail} Verification cartouches read-only"
Cde="dsmadmc -id=${UserTSm} -pa=${PassTsm} QUERY 'VOLUME' ACC='READO'"
RequeteDDe

#
#---------------------------------------------
# Verification NODES Locked
#---------------------------------------------
#
LibMail="${TitreMail} Verification NODES Locked"
Cde="${PathScripts}/SMIT_TSM/Select_Table_TSM.ksh COLAFFICHE='NODE_NAME' TABLE='NODES' COLCIBLE='LOCKED                 ENUMERATED(YESNO_-' CRITCIBLE='=' VALCIBLE='YES' SQLDISPLAYMODE='Narrow'"
RequeteDDe

#
#---------------------------------------------
# Verification ERREUR
#---------------------------------------------
#
LibMail="${TitreMail} ERREURS "
Cde="dsmadmc -id=${UserTSm} -pa=${PassTsm}  QUERY 'ACTLOG' BEGINTIME='-1' SEARCH='ANR????E' ORIGINATOR='ALL'"
RequeteDDe

#
#---------------------------------------------
# Verification WARNINGS
#---------------------------------------------
#
LibMail="${TitreMail} WARNINGS"
Cde="dsmadmc -id=${UserTSm} -pa=${PassTsm}  QUERY 'ACTLOG' BEGINTIME='-1' SEARCH='ANR????W' ORIGINATOR='ALL'"
RequeteDDe

#
#---------------------------------------------
# Demande ouverture du CAP 0,1,1
#---------------------------------------------
#
LibMail="${TitreMail} Demande ouverture du CAP 0,1,1"
Cde="dsmadmc -id=${UserTSm} -pa=${PassTsm}  QUERY ACTLOG BEGINTIME=-1 MSGNO=8861 ORIGINATOR=ALL"
RequeteDDe

#
#---------------------------------------------
# Les cartouches qui sont ejectes ( apres cap close )
#---------------------------------------------
#
LibMail="${TitreMail} Les cartouches qui sont ejectees ( apres cap close )"
Cde="dsmadmc -id=${UserTSm} -pa=${PassTsm}  QUERY ACTLOG BEGINTIME=-1 MSGNO=8438 ORIGINATOR=ALL | awk 'BEGIN { tot=0 }{ if ( \$7 == \"volume\" ) { print \$8 ; tot++ } } END { if ( tot == 0 ) print \"ANS8001I Return code 11\"}' | sort "
RequeteDDe

#
#---------------------------------------------
# Les cartouches qui doivent aller chez memogarde
#---------------------------------------------
#
LibMail="${TitreMail} Les cartouches qui doivent aller chez memogarde"
Cde="dsmadmc -id=${UserTSm} -pa=${PassTsm}  QUERY ACTLOG BEGINTIME=-1 MSGNO=6683 ORIGINATOR=ALL | awk 'BEGIN { tot=0 }{ if ( \$6 == \"Volume\" ) { print \$7 ; tot++ } } END { if ( tot == 0 ) print \"ANS8001I Return code 11\" }' | sort "
RequeteDDe

#
#---------------------------------------------
# Les cartouches qui sont write protect
#---------------------------------------------
#
LibMail="${TitreMail} Les cartouches qui sont write protected"
if test $( date +%H%M ) -gt 0800
 then
Cde="dsmadmc -id=${UserTSm} -pa=${PassTsm}  QUERY ACTLOG BEGINTIME=-1 MSGNO=8463 ORIGINATOR=ALL"
 else
Cde="dsmadmc -id=${UserTSm} -pa=${PassTsm}  QUERY ACTLOG BEGINDATE=-1 MSGNO=8463 ORIGINATOR=ALL"
fi
RequeteDDe


#
#---------------------------------------------
# Nombre de scratchs disponibles
#---------------------------------------------
#
## LibMail="${TitreMail} Nombre de scraths disponibles"
## if test $( date +%H%M ) -gt 1200
## then
## Cde="${PathScripts}/SMIT_TSM/Select_Table_TSM.ksh COLAFFICHE='count(VOLUME_NAME)' TABLE='LIBVOLUMES' COLCIBLE='LIBRARY_NAME  VARCHAR' CRITCIBLE='=' VALCIBLE='SL8500' SQLDISPLAYMODE='Narrow' REQSAISIE='and STATUS = #Scratch#'"
## fi
## RequeteDDe

## if [ $( date +%H%M ) -gt 1400  -a  $( date +%H%M ) -lt 1600 ]
##  then
## NbrTotVol=$( dsmadmc -id=${UserTSm} -pa=${PassTsm}  "select count(VOLUME_NAME) from LIBVOLUMES where LIBRARY_NAME = 'SL8500'" | tail +13 | head -n 1 )
## NbrTotVolScratch=$( dsmadmc -id=${UserTSm} -pa=${PassTsm}  "select count(VOLUME_NAME) from LIBVOLUMES where LIBRARY_NAME = 'SL8500' and STATUS = 'Scratch'" | tail +13 | head -n 1 )
## NbrTotPercent=$NbrTotVolScratch
## (( NbrTotPercent*=100 ))
## (( NbrTotPercent/=NbrTotVol ))
## LibMail="${TitreMail} $NbrTotVolScratch scratchs disponibles soit $NbrTotPercent%"
## Cde="echo $LibMail nombre total volumes $NbrTotVol"
## RequeteDDe
## fi
#
#---------------------------------------------
# Count Nbre bandes Volrange et scratchs
#---------------------------------------------
#
if [ $( date +%H%M ) -gt 1400  -a  $( date +%H%M ) -lt 1600 ]
then
Cde="$( dirname $0 )/Count_Nbre_Bandes_Volrange.ksh"
LibMail="${TitreMail} Count Control Bandes Volrange et $( ${Cde} >/dev/null ; echo $? )% de scratchs"
RequeteDDe
exit 0
fi
