#!/bin/ksh
#=========================================================================
#
#  Ficname     : Backup_Stg_RESEAU.ksh
#
#  Redacteur   : JF.GONZALEZ GARCIA
#  Copyright   : CIMAFAP-NANTERRE
#  date        : 27 mai 2011
#  Projet      : TSM
#  Version     : 1.0
#
#  Description : BACKUP Des storages pools primaires RESEAU
#
#=========================================================================
#

. ${PATH_TSM}/scripts/profile_scripts

#------ retrait sortie si erreur
set +e

#******************************************************************************************
# BACKUP STG
# Cette commande permet de copier les pools primaires sur secondaires pour externalisation
#******************************************************************************************

CtrlRC()
{
CR=$1 ; [[ $CR -eq  11 ]] && CR=0 ; (( RC+=CR ))
}

#-------- Recup param transmis par ControlM ODATE APPLICATION SCHEDTAB JOBNAME
while [ $# -gt 0 ]
do
eval $1
shift
done

#-------------------------- 
#-------------------------- Copie des STGs primaires sur copy
#--------------------------
RC=0 ; CR=0

AccesTsm="dsmadmc -id=${TsM_uSer} -pa=${TsM_pAss}"

${AccesTsm} ba stg STG_TAPESL8500_RESEAU_APP STG_COPY_RESEAU_APP_SL8500 maxprocess=3 wait=yes
CtrlRC $?

${AccesTsm} ba stg STG_TAPESL8500_RESEAU_COLLOC  STG_COPY_RESEAU_APP_COLLO_8500 maxprocess=3 wait=yes
CtrlRC $?

${AccesTsm} ba stg STG_TAPE_APP_CFT_ARC_L  STG_COPY_APP_CFT_ARC_L maxprocess=1 wait=yes
CtrlRC $?

${AccesTsm} ba stg ST_BKUP_KVM STG_COPY_RESEAU_APP_COLLO_8500
CtrlRC $?

${AccesTsm} ba stg STG_VTL2_CIMAFAP_RESO_BKP_C  STG_COPY_X86_VTL_SL8500  maxprocess=2 wait=yes
CtrlRC $?

#--------- Si probleme juste avertir par mail aller voir sysout
[[ $RC -gt 0 ]] && mail -s"[ KO - TSM ] RC=$RC - ODATE=${ODATE} APPLICATION=${APPLICATION} SCHEDTAB=${SCHEDTAB} JOBNAME=${JOBNAME} Aller voir sysout " exploitationnanterresuivitechniqueunix.grprec@cimafap.msa.fr

exit 0


