#!/bin/ksh
#=========================================================================
#
#  Ficname     : Backup_Stg_VTL1.ksh
#
#  Redacteur   : JF.GONZALEZ GARCIA
#  Copyright   : CIMAFAP-NANTERRE
#  date        : 27 mai 2011
#  Projet      : TSM
#  Version     : 1.0
#
#  Description : BACKUP Des storages pools primaires
#
#=========================================================================
#

. ${PATH_TSM}/scripts/profile_scripts

#------ retrait sortie si erreur
set +e

#******************************************************************************************
# BACKUP STG
# Cette commande permet de copier les pools primaires sur secondaires pour externalisation
#******************************************************************************************

CtrlRC()
{
CR=$1 ; [[ $CR -eq  11 ]] && CR=0 ; (( RC+=CR ))
}

#-------- Recup param transmis par ControlM ODATE APPLICATION SCHEDTAB JOBNAME
while [ $# -gt 0 ]
do
eval $1
shift
done

#--------------------------
#-------------------------- Copie des STGs primaires sur copy
#--------------------------
RC=0 ; CR=0

StgCopy=ST_BKUP_COPY

#--------- maxprocess a 3 en semaine a 3 si dimanche
MaxProcess=3
test $( date +%w ) -eq 0 && MaxProcess=3

dsmadmc -id=${TsM_uSer} -pa=${TsM_pAss} ba stg STG_VTL1_CIMAFAP_TECH_BKP_C ${StgCopy} maxprocess=${MaxProcess} wait=yes
CtrlRC $?

dsmadmc -id=${TsM_uSer} -pa=${TsM_pAss} ba stg STG_VTL1_CIMAFAP_INC_BKP_C ${StgCopy} maxprocess=1 wait=yes
CtrlRC $?

dsmadmc -id=${TsM_uSer} -pa=${TsM_pAss} ba stg STG_VTL1_CIMAFAP_CFT_ARC_L_C ${StgCopy} maxprocess=1 wait=yes
CtrlRC $?

#--------- Si probleme juste avertir par mail aller voir sysout
[[ $RC -gt 0 ]] && mail -s"[ KO - TSM ] RC=$RC - ODATE=${ODATE} APPLICATION=${APPLICATION} SCHEDTAB=${SCHEDTAB} JOBNAME=${JOBNAME} Aller voir sysout " exploitationnanterresuivitechniqueunix.grprec@cimafap.msa.fr

exit 0
