#!/bin/ksh
#=========================================================================
#
#  Ficname     : CtrlVolManquant.ksh
#
#  Redacteur   : JF.GONZALEZ GARCIA
#  Copyright   : CIMAFAP-NANTERRE
#  date        : 20 mai 2011
#  Projet      : TSM
#  Version     : 1.0
#
#  Description : Controler si volume manquants
#                Si oui inscrire dans fichier  ./data/DRM/Liste_K7_Manquantes_AjoutUser.txt
#
#=========================================================================
#
exit
. ${PATH_TSM}/scripts/profile_scripts

test $# -eq 1 && set +av

#**********************************************************************************
#
# Rechercher les bandes SL8500 egarees
#
# d apres des ranges defini on aura l exhaustivite des cartouches definies
# on liste celles connues de TSM
# on sort les manquantes
#
#**********************************************************************************

fictout=/tmp/VOLUME_NAME_TOUT_$$
ficinout=/tmp/VOLUME_NAME_InOut_$$

#ranges="\
# 921441#921489"
#for pool in ${ranges}

#===========================================================
#
# ${PATH_TSM}/data/volrange.txt
#
# fichier contenant les ranges a traiter
#===========================================================
#
for pool in $( sed "s/volrange=/ /;s/,/#/" ${PATH_TSM}/data/volrange.txt )
do
  deb=$( echo $pool | cut -d"#" -f1 )
  fin=$( echo $pool | cut -d"#" -f2 )

  encour=$deb

  while [ $encour -le $fin ]
  do
   echo $encour >> ${fictout}
   (( encour+=1 ))
  done
done

dsmadmc -id=${TsM_uSer}  -pa=${TsM_pAss} << @EOFF | grep ^92 | sort | sed 's/ //g' > ${ficinout}
select VOLUME_NAME from libvolumes where library_name = 'SL8500'
select VOLUME_NAME from drmedia
quit
@EOFF

set +e

nbmanq=$( diff ${fictout} ${ficinout} | grep -c '<' )
cartmanq="$( diff ${fictout} ${ficinout} | grep '<' | sed 's/<//g' )"

#---------- Pas d envoi mail si parm1 est valorise

if test -z "$1"
then
#----------- Incrire cartouche manquante dans fichier cartouches a reclamer
if test ${nbmanq} -gt 0
then
 for cartouch in ${cartmanq}
   do
       echo ${cartouch} >> ${PATH_TSM}/data/DRM/Liste_K7_Manquantes_AjoutUser.txt
   done
fi

SUBJ="[ TSM - $( uname -n ) ] ${nbmanq} cartouches manquantes "
TO=exploitationnanterresuivitechniqueunix.grprec@cimafap.msa.fr
(
cat << !
To : ${TO}
Cc :
Subject : ${SUBJ}
Bonjour,

Voici la liste des cartouches manquantes sur $( uname -n )
Cartouches incrites dans fichier ${PATH_TSM}/data/DRM/Liste_K7_Manquantes_AjoutUser.txt

${cartmanq}

Voici la liste des cartouches incrites dans fichier ${PATH_TSM}/data/DRM/Liste_K7_Manquantes_AjoutUser.txt
qui seront ajoutees  la liste des cartouches, VAULT RETRIEVE,  reclamer  IRON MOUNTAIN

$( cat ${PATH_TSM}/data/DRM/Liste_K7_Manquantes_AjoutUser.txt )

!
) |  sendmail -v ${TO}

else

cat << @EOFF
Bonjour,

Voici la liste des cartouches manquantes sur $( uname -n )
Cartouches incrites dans fichier ${PATH_TSM}/data/DRM/Liste_K7_Manquantes_AjoutUser.txt

${cartmanq}

Voici la liste des cartouches incrites dans fichier ${PATH_TSM}/data/DRM/Liste_K7_Manquantes_AjoutUser.txt
qui seront ajoutees  la liste des cartouches, VAULT RETRIEVE,  reclamer  IRON MOUNTAIN

$( cat ${PATH_TSM}/data/DRM/Liste_K7_Manquantes_AjoutUser.txt )

@EOFF
fi

rm /tmp/VOLUME_NAME_*$$*
